/* Sistemas Integrados TECNISA
   Servios

Nome: BUSCA_LOCAL

Descrio:
   Retorna o Local de estoque do produto.
Criao:
28/07/05 - Welbert G. Moitinha */

CREATE OR REPLACE FUNCTION BUSCA_LOCAL( P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
                                        P_CDLOJA    IN LOJA.CDLOJA%TYPE,
                                        P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE)RETURN VARCHAR2
AS
   V_CDLOCALESTOQ LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_IDCTRLESTQ   PARAMFILIAL.IDCTRLESTQ%TYPE;
   V_IDUTILLCESTQ PARAMFILIAL.IDUTILLCESTQ%TYPE;
   V_CDLOCALPROD  LOCALESTOQUE.CDLOCALESTOQ%TYPE;
   V_CDALMOXARIFE PARAMFILIAL.CDALMOXARIFE%TYPE;
BEGIN
   SELECT
      MAX(IDUTILLCESTQ), MAX(IDCTRLESTQ), MAX(CDLOCALESTOQ)
   INTO V_IDUTILLCESTQ, V_IDCTRLESTQ, V_CDLOCALESTOQ
   FROM
      PARAMFILIAL
   WHERE
      (CDFILIAL = P_CDFILIAL);

   IF(V_IDCTRLESTQ <> 'N')  AND(V_IDUTILLCESTQ = 'S')THEN
      SELECT MAX(CDALMOXPRCLI), MAX(CDLOCALPRCLI)
      INTO V_CDALMOXARIFE, V_CDLOCALPROD
      FROM PRODFILI PF, PRODUTO P
      WHERE PF.CDFILIAL  = P_CDFILIAL  AND
            P.CDPRODUTO  = P_CDPRODUTO AND
            PF.CDPRODUTO = P.CDPRODESTO;

      IF(V_CDLOCALPROD IS NOT NULL)AND(V_CDALMOXARIFE IS NOT NULL)THEN
         RETURN(V_CDLOCALPROD);
      ELSE
         SELECT MAX(CDLOCALESTOQ)
           INTO V_CDLOCALPROD
           FROM LOJA
          WHERE CDFILIAL = P_CDFILIAL
            AND CDLOJA = P_CDLOJA;

         IF (V_CDLOCALPROD IS NOT NULL) THEN
            RETURN(V_CDLOCALPROD);
         ELSE
            IF (V_CDLOCALESTOQ IS NOT NULL)THEN
               RETURN(V_CDLOCALESTOQ);
            ELSE
               RETURN(' ');
            END IF;
         END IF;
      END IF;
   ELSE
      RETURN(' ');
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_LOCAL','5.05.007'); END;
/

